## vart 2.5

=== CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
#
cmake_minimum_required(VERSION 3.12)
project(
  vart
  VERSION 2.5.0
  LANGUAGES C CXX)

link_directories("$ENV{CONDA_PREFIX}/lib")
include(${PROJECT_SOURCE_DIR}/cmake/VitisCommon.cmake)

option(ENABLE_CPU_RUNNER "enable cpu runner or not" OFF)
option(ENABLE_SIM_RUNNER "enable sim runner or not" OFF)
option(ENABLE_DPU_RUNNER "enable dpu runner or not" OFF)
option(ENABLE_XRNN_RUNNER "enable xrnn runner or not" OFF)
option(ENABLE_RNN_RUNNER "enable rnn runner or not" OFF)
option(BUILD_PYTHON "build python library" OFF)
option(BUILD_TEST "build test" OFF)

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${PROJECT_SOURCE_DIR}/cmake")
find_package(glog QUIET)
if(NOT glog_FOUND)
  message(STATUS "cannot find glogConfig.cmake fallback to pkg-config")
  find_package(PkgConfig)
  pkg_search_module(PKG_GLOG REQUIRED IMPORTED_TARGET GLOBAL libglog)
  add_library(glog::glog ALIAS PkgConfig::PKG_GLOG)
endif(NOT glog_FOUND)
find_package(Protobuf REQUIRED)
if(${CMAKE_SOURCE_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
  find_package(unilog REQUIRED)
  find_package(xir REQUIRED)
  find_package(target-factory REQUIRED)
endif()
find_package(Threads REQUIRED)
find_package(XRT HINTS /opt/xilinx/xrt/share/cmake/XRT)
if(XRT_FOUND)
  # bugfix for XRT.cmake
  set_target_properties(XRT::xrt_core PROPERTIES INTERFACE_INCLUDE_DIRECTORIES
                                                 ${XRT_INCLUDE_DIRS})
else(XRT_FOUND)
  include(${CMAKE_SOURCE_DIR}/cmake/my_find_xrt.cmake)
endif(XRT_FOUND)

if(${XRT_FOUND})
  if(IS_EDGE)
    set(XRT_EDGE_FOUND true)
    set(XRT_CLOUD_FOUND false)
  else()
    set(XRT_EDGE_FOUND false)
    set(XRT_CLOUD_FOUND true)
  endif()
else(${XRT_FOUND})
  set(XRT_EDGE_FOUND false)
  set(XRT_CLOUD_FOUND false)
endif(${XRT_FOUND})
find_package(hiredis QUIET)

set(PACKAGE_COMPONENTS util runner trace)
if(NOT MSVC)
  # thread pool does not work on MSVC because the bug
  # https://developercommunity.visualstudio.com/t/unable-to-move-stdpackaged-task-into-any-stl-conta/10867
  list(APPEND PACKAGE_COMPONENTS dummy-runner async-runner)
endif(NOT MSVC)
list(APPEND PACKAGE_COMPONENTS mem-manager)
if(ENABLE_DPU_RUNNER)
  # append xrt-device-handle anyway, even if xrt is not found, because softmax
  # controller is part if and vitis-ai-library needs such components.
  list(APPEND PACKAGE_COMPONENTS xrt-device-handle)
  list(APPEND PACKAGE_COMPONENTS buffer-object dpu-controller dpu-runner)
  if(IS_EDGE)
    list(APPEND PACKAGE_COMPONENTS softmax-runner softmax-runner-cpu)
  endif(IS_EDGE)
endif()
if(ENABLE_SIM_RUNNER)
  list(APPEND PACKAGE_COMPONENTS sim-runner)
endif()
if(ENABLE_CPU_RUNNER)
  list(APPEND PACKAGE_COMPONENTS cpu-runner)
endif()
if(ENABLE_XRNN_RUNNER)
  list(APPEND PACKAGE_COMPONENTS xrt-device-handle)
  list(APPEND PACKAGE_COMPONENTS buffer-object xrnn-runner)
endif()
if(ENABLE_RNN_RUNNER)
  list(APPEND PACKAGE_COMPONENTS xrt-device-handle)
  list(APPEND PACKAGE_COMPONENTS buffer-object rnn-runner)
endif()

list(REMOVE_DUPLICATES PACKAGE_COMPONENTS)
foreach(COMPONENT ${PACKAGE_COMPONENTS})
  add_subdirectory(${COMPONENT})
endforeach()

file(RELATIVE_PATH REL_INCLUDE_DIR
     ${CMAKE_INSTALL_PREFIX}/share/cmake/${PROJECT_NAME}
     ${CMAKE_INSTALL_PREFIX}/include)
set(CONF_INCLUDE_DIRS "\${${PROJECT_NAME}_CMAKE_DIR}/${REL_INCLUDE_DIR}")
configure_file(cmake/config.cmake.in
               "${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config.cmake" @ONLY)

write_basic_package_version_file(
  "${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY AnyNewerVersion)

install(
  FILES "${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
        "${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  COMPONENT base
  DESTINATION share/cmake/${PROJECT_NAME})

set(CPACK_PACKAGE_NAME "libvart")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Vitis Ai RuntTime")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_README "${PROJECT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/Copyright.txt")
set(CPACK_PACKAGE_VENDOR "Humanity")
set(CPACK_PACKAGE_VERSION_MAJOR ${CMAKE_PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${CMAKE_PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${CMAKE_PROJECT_VERSION_PATCH})
set(CPACK_PACKAGE_CONTACT "Hui Zhang<huizhang@xilinx.com>")
set(CPACK_PACKAGING_INSTALL_PREFIX "/usr")

set(CPACK_DEB_COMPONENT_INSTALL ON)
set(CPACK_DEBIAN_ENABLE_COMPONENT_DEPENDS ON)
set(CPACK_DEBIAN_PACKAGE_SECTION "devel")
set(CPACK_DEBIAN_ARCHIVE_TYPE "gnutar")
set(CPACK_DEBIAN_COMPRESSION_TYPE "gzip")
set(CPACK_DEBIAN_PACKAGE_PRIORITY "optional")
set(CPACK_DEBIAN_PACKAGE_DEPENDS
    "libxir (>=1.2.0), libunilog (>=1.2.0), libtarget-factory (>=1.2.0)")
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
if(DEFINED ENV{BUILD_NUMBER})
  set(CPACK_DEBIAN_PACKAGE_RELEASE "r$ENV{BUILD_NUMBER}")
endif()
if(CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
  set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "arm64")
elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
  set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")
else()
  set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
endif()

set(CPACK_RPM_COMPONENT_INSTALL ON)
set(CPACK_RPM_PACKAGE_LICENSE "Apache")
set(CPACK_RPM_PACKAGE_GROUP "Development/Tools")
set(CPACK_RPM_COMPRESSION_TYPE "xz")
set(CPACK_RPM_PACKAGE_REQUIRES
    "libxir >= 1.2.0, libunilog >= 1.2.0, libtarget-factory >= 1.2.0")
set(CPACK_RPM_FILE_NAME RPM-DEFAULT)
if(DEFINED ENV{BUILD_NUMBER})
  set(CPACK_RPM_PACKAGE_RELEASE "r$ENV{BUILD_NUMBER}")
endif()
set(CPACK_RPM_PACKAGE_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
if(CMAKE_SYSTEM_PROCESSOR STREQUAL "cortexa72-cortexa53")
  set(CPACK_RPM_PACKAGE_ARCHITECTURE "aarch64")
endif()

set(CPACK_COMPONENTS_GROUPING ALL_COMPONENTS_IN_ONE)

include(CPack)
cpack_add_component_group(all)
cpack_add_component(base GROUP all)
cpack_add_component(
  cpu
  GROUP all
  DEPENDS base)
cpack_add_component(
  dpu
  GROUP all
  DEPENDS base)
cpack_add_component(
  sim
  GROUP all
  DEPENDS base)

=== runner-assistant/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
#
get_filename_component(COMPONENT_NAME "${CMAKE_CURRENT_SOURCE_DIR}" NAME)
add_library(
  ${COMPONENT_NAME} SHARED
  include/vart/assistant/batch_tensor_buffer.hpp
  src/batch_tensor_buffer.cpp
  src/tensor_mirror_attrs.cpp
  include/vart/assistant/tensor_buffer_allocator.hpp
  src/tensor_buffer_allocator.cpp
  src/tensor_buffer_imp_host.cpp
  src/tensor_buffer_imp_host.hpp
  src/tensor_buffer_imp_host_phy.cpp
  src/tensor_buffer_imp_host_phy.hpp
  src/tensor_buffer_imp_view.cpp
  src/tensor_buffer_imp_view.hpp
  src/tensor_buffer_allocator_imp.cpp
  src/tensor_buffer_allocator_imp.hpp)

if(XRT_FOUND)
  target_compile_definitions(${COMPONENT_NAME} PRIVATE -DXRT_FOUND)
endif(XRT_FOUND)

target_sources(
  ${COMPONENT_NAME} PRIVATE include/vart/assistant/xrt_bo_tensor_buffer.hpp
                            src/xrt_bo_tensor_buffer.cpp)
if(XRT_FOUND)
  target_link_libraries(${COMPONENT_NAME} PRIVATE XRT::xrt_core)
endif(XRT_FOUND)

add_library(${PROJECT_NAME}::${COMPONENT_NAME} ALIAS ${COMPONENT_NAME})
target_link_libraries(
  ${COMPONENT_NAME}
  PUBLIC ${PROJECT_NAME}::runner
  PRIVATE ${PROJECT_NAME}::buffer-object)

target_include_directories(
  ${COMPONENT_NAME}
  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
         $<INSTALL_INTERFACE:include>)
set_target_properties(
  ${COMPONENT_NAME}
  PROPERTIES VERSION "${PROJECT_VERSION}"
             SOVERSION "${PROJECT_VERSION_MAJOR}"
             LIBRARY_OUTPUT_NAME ${PROJECT_NAME}-${COMPONENT_NAME})
install(
  TARGETS ${COMPONENT_NAME}
  EXPORT ${COMPONENT_NAME}-targets
  COMPONENT dpu
  RUNTIME DESTINATION bin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib)
install(
  FILES include/vart/assistant/batch_tensor_buffer.hpp
        include/vart/assistant/tensor_mirror_attrs.hpp
        include/vart/assistant/tensor_buffer_allocator.hpp
        include/vart/assistant/xrt_bo_tensor_buffer.hpp
  DESTINATION include/vart/assistant/)

install(
  EXPORT ${COMPONENT_NAME}-targets
  NAMESPACE ${PROJECT_NAME}::
  COMPONENT dpu
  DESTINATION share/cmake/${PROJECT_NAME})

add_executable(test_batch_tensor_buffer test/test_batch_tensor_buffer.cpp)
target_link_libraries(test_batch_tensor_buffer)

if(XRT_FOUND)
  add_executable(test_xrt_bo_tensor_buffer test/test_xrt_bo_tensor_buffer.cpp)
  target_link_libraries(test_xrt_bo_tensor_buffer ${COMPONENT_NAME}
                        XRT::xrt_core ${PROJECT_NAME}::util)
endif(XRT_FOUND)

add_executable(test_allocator test/test_allocator.cpp)
target_link_libraries(test_allocator ${COMPONENT_NAME} ${PROJECT_NAME}::util
                      ${CMAKE_THREAD_LIBS_INIT})

=== samples/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
cmake_minimum_required(VERSION 3.12)

project(vart_samples)

find_package(OpenCV REQUIRED)
find_package(unilog REQUIRED)
find_package(xir REQUIRED)
find_package(
  vart
  COMPONENTS util
             xrt-device-handle
             buffer-object
             dpu-controller
             runner
             dpu-runner
             runner-assistant
             mem-manager
  REQUIRED)
include(${CMAKE_SOURCE_DIR}/cmake/my_find_xrt.cmake)
include_directories(common)

function(vart_add_sample name)
  set(options "")
  set(oneValueArgs DESTINATION)
  set(multiValueArgs REQUIRE SRCS)
  cmake_parse_arguments(ARG "${options}" "${oneValueArgs}" "${multiValueArgs}"
                        ${ARGN})

  add_executable(${name} ${ARG_SRCS})
  target_link_libraries(
  ${name} unilog::unilog xir::xir vart::runner ${OpenCV_LIBS} pthread)

  if(ARG_REQUIRE)
    target_link_libraries(${name} ${ARG_REQUIRE})
  endif(ARG_REQUIRE)
endfunction(vart_add_sample)

vart_add_sample(
  adas_detection
  SRCS adas_detection/src/main.cc
       common/common.cpp)

vart_add_sample(
  pose_detection
  SRCS pose_detection/src/main.cpp
       pose_detection/src/ssd.cpp
       pose_detection/src/pose.cpp
       common/common.cpp)

vart_add_sample(
  resnet50
  SRCS resnet50/src/main.cc
       common/common.cpp)

vart_add_sample(
  resnet50_ext
  SRCS resnet50_ext/resnet50.cpp
  REQUIRE vart::dpu-controller vart::xrt-device-handle vart::buffer-object
          vart::util vart::runner-assistant)

vart_add_sample(
  resnet50_pt
  SRCS resnet50_pt/resnet50_pt.cpp
  REQUIRE vart::dpu-controller vart::xrt-device-handle vart::buffer-object
          vart::util vart::runner-assistant)

vart_add_sample(
  resnet50_zero_copy
  SRCS resnet50_zero_copy/resnet50.cpp
  REQUIRE XRT::xrt_core XRT::xrt_coreutil vart::dpu-controller vart::xrt-device-handle
          vart::buffer-object vart::util vart::runner-assistant)

vart_add_sample(
  segmentation
  SRCS segmentation/src/main.cc
       common/common.cpp)

vart_add_sample(
  squeezenet_pytorch
  SRCS squeezenet_pytorch/src/main.cc
       common/common.cpp)

vart_add_sample(
  video_analysis
  SRCS video_analysis/src/main.cc
       common/common.cpp)

=== test/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
#
option(ENABLE_PACK_TRD "Enable create tar.gz for TRD" OFF)
aux_source_directory(. TEST_SRC)

execute_process(
  COMMAND
    bash -ex ${CMAKE_CURRENT_SOURCE_DIR}/convert_word_list.sh
    ${CMAKE_CURRENT_SOURCE_DIR}/word_list.txt
    ${CMAKE_CURRENT_BINARY_DIR}/word_list.inc)
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

find_package(OpenCV REQUIRED)
if(MSVC)
  set(TEST_SRCS test_dpu_runner.cpp test_dpu_runner_mt.cpp)
else(MSVC)
  # for WINDOWS, because word_list.inc is not generated, we remove resnet50.cpp
  set(TEST_SRCS test_dpu_runner.cpp resnet50.cpp test_dpu_runner_mt.cpp)
endif(MSVC)
foreach(FNAME ${TEST_SRCS})
  get_filename_component(F_PREFIX ${FNAME} NAME_WE)
  set(ELF ${F_PREFIX})

  add_executable(${ELF} ${FNAME})
  target_link_libraries(
    ${ELF}
    ${COMPONENT_NAME}
    xir::xir
    glog::glog
    util
    mem-manager
    ${OpenCV_LIBS}
    ${CMAKE_THREAD_LIBS_INIT})
endforeach()

if(MSVC)

else(MSVC)
  # TRD packaging is not supported for windows yet.
  if(ENABLE_PACK_TRD)
    install(
      CODE "execute_process (
    COMMAND env CMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX} CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR} CMAKE_CURRENT_BINARY_DIR=${CMAKE_CURRENT_BINARY_DIR} bash ${CMAKE_CURRENT_SOURCE_DIR}/pack_for_trd.sh
)")
  endif(ENABLE_PACK_TRD)
endif(MSVC)

if(XRT_FOUND)
  add_executable(xvdpu_profiler ${CMAKE_CURRENT_SOURCE_DIR}/xvdpu_profiler.cpp)
  target_link_libraries(
    xvdpu_profiler 
    xir::xir 
    glog::glog 
    XRT::xrt_core
    xrt-device-handle 
    buffer-object 
    runner
    dpu-runner) 
  install(TARGETS xvdpu_profiler DESTINATION bin)
endif(XRT_FOUND)
# add_executable (resnet50_zero_copy ../samples/resnet50_zero_copy/resnet50.cpp)
# target_link_libraries (resnet50_zero_copy ${COMPONENT_NAME}
# ${PROJECT_NAME}::runner dpu-controller opencv_core opencv_video opencv_videoio
# opencv_imgproc opencv_imgcodecs opencv_highgui XRT::XRT )

=== test_cloud/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
aux_source_directory(. TEST_SRC)
foreach(FNAME ${TEST_SRC})
  get_filename_component(F_PREFIX ${FNAME} NAME_WE)
  set(ELF ${F_PREFIX})

  add_executable(${ELF} ${FNAME})
  target_link_libraries(${ELF}
    ${COMPONENT_NAME} xir::xir glog::glog ${OpenCV_LIBS} ${CMAKE_THREAD_LIBS_INIT})
endforeach()

=== vaitrace/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
#

cmake_minimum_required(VERSION 3.5)
project(vaitrace VERSION 2.5.20221)
set(VAITRACE_DEST_PATH bin/xlnx/${PROJECT_NAME})

# Generate Version Flags
execute_process(COMMAND date +%F-%T OUTPUT_VARIABLE VAITRACE_BUILD_DATE)
string(STRIP "${VAITRACE_BUILD_DATE}" VAITRACE_BUILD_DATE)
execute_process(
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND git rev-parse --short HEAD
  OUTPUT_VARIABLE VAITRACE_GIT_VERSION)
string(STRIP "${VAITRACE_GIT_VERSION}" VAITRACE_GIT_VERSION)
configure_file(vaitrace_version.in
               ${CMAKE_CURRENT_BINARY_DIR}/vaitrace_version.py)

install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/vaitrace_version.py
        DESTINATION ${VAITRACE_DEST_PATH})

# Build xapm Library
if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "aarch64")
  # g++ -shared apm.cpp apm_shell.cpp -fPIC -o libxapm.so -I./include
  set(XAPM_DIR ${CMAKE_CURRENT_SOURCE_DIR}/vaitraceTools/xapm)
  include_directories(${XAPM_DIR}/include)

  add_library(xapm SHARED ${XAPM_DIR}/apm.cpp ${XAPM_DIR}/apm_shell.cpp)

  target_link_libraries(xapm pthread)
  set_target_properties(xapm PROPERTIES VERSION "${PROJECT_VERSION}"
                                        SOVERSION "${PROJECT_VERSION_MAJOR}")

  install(TARGETS xapm DESTINATION lib)
endif()

# Build DpuMcParser Library
if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "aarch64")
  set(DPU_MC_PATH writer/parser/dpu_mc_parser)
  set(DPU_MC_SRC ${CMAKE_CURRENT_SOURCE_DIR}/${DPU_MC_PATH})
  set(DPU_MC_DEST ${VAITRACE_DEST_PATH}/${DPU_MC_PATH})
  include_directories(${DPU_MC_SRC})
  aux_source_directory(${DPU_MC_SRC} DPU_MC_SRC_FILES)
  foreach(SRC IN ITEMS  ${DPU_MC_SRC_FILES})
    get_filename_component(_N ${SRC} NAME_WE)
    add_library(${_N} SHARED ${SRC})
    #set_target_properties(${_N} PROPERTIES VERSION "${PROJECT_VERSION}"
    #                       SOVERSION "${PROJECT_VERSION_MAJOR}")
    install(
      FILES ${CMAKE_CURRENT_BINARY_DIR}/lib${_N}.so
      DESTINATION ${DPU_MC_DEST}
      RENAME ${_N}.so
    )
  endforeach()
endif()

install(
  DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
  DESTINATION ${VAITRACE_DEST_PATH}
  FILES_MATCHING
  PATTERN "*.py"
  PATTERN __pycache__ EXCLUDE
  PATTERN ".*" EXCLUDE
  PATTERN script EXCLUDE
  PATTERN test_cfg EXCLUDE
  PATTERN time_sync EXCLUDE
  PATTERN build EXCLUDE
  PATTERN vaitrace_py EXCLUDE
  PATTERN vaitraceTools/xapm EXCLUDE
  PATTERN vaitrace.py PERMISSIONS WORLD_EXECUTE WORLD_READ GROUP_EXECUTE
                                  GROUP_READ OWNER_EXECUTE OWNER_READ)

# Create Symbol Link
if(NOT MSVC)
  # MSVC does not support symlink properly.
  execute_process(
    COMMAND ${CMAKE_COMMAND} -E create_symlink ./xlnx/${PROJECT_NAME}/vaitrace.py
    ${CMAKE_CURRENT_BINARY_DIR}/vaitrace)
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/vaitrace DESTINATION bin)
endif(NOT MSVC)

# Build Python
if(BUILD_PYTHON)
  set(VAITRACE_PY_INSTALL_DIR ${PYTHON_SITE_PACKAGES})
  install(
    DIRECTORY python/vaitrace_py
    DESTINATION ${VAITRACE_PY_INSTALL_DIR}
    FILES_MATCHING
    PATTERN "*.py")
endif()

set(CPACK_PACKAGE_NAME "vaitrace")
set(CPACK_PACKAGE_VENDOR "Humanity")
set(CPACK_SET_DESTDIR OFF)
set(CPACK_PACKAGE_CONTACT "LiYunzhi<liyunzhi@xilinx.com>")
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_RPM_FILE_NAME RPM-DEFAULT)
set(CPACK_RPM_PACKAGE_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
include(CPack)

=== vaitrace/vaitraceTools/xapm/Makefile ===

# Copyright (C) Xilinx .Ltd, 2019. All rights reserved.
#

PROJECT_NAME=libxapm
TARGET=$(PROJECT_NAME).so

CC=$(CROSS_COMPILE)g++

CFLAGS = -shared -fPIC -I./include -lstdc++

RM=rm -rf $(1)
CP=cp $(1) $(2)

SRCS = apm.cpp apm_shell.cpp

all:
	$(CC) $(CFLAGS) $(SRCS) -o $(TARGET)
ifneq ($(OUT),)
	$(call CP,$(TARGET),$(OUT))
endif

clean:
	$(call RM,*.o)
	$(call RM,*.so)

=== vaitrace/writer/parser/dpu_mc_parser/Makefile ===

# Copyright (C) Xilinx .Ltd, 2019. All rights reserved.
#

CC=$(CROSS_COMPILE)g++

CFLAGS = -shared -O3 -fPIC -std=c++11

RM=rm -rf $(1)
CP=cp $(1) $(2)

all: $(subst .cpp,.so,$(wildcard *dpu*.cpp))

%.so: %.cpp
	$(CC) $(CFLAGS)  $< -o $@ 

clean:
	$(call RM,*.o)
	$(call RM,*.so)

=== debian/changelog ===
vart (2.5-5build1) resolute; urgency=medium

  * Rebuild against latest xrt

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 01 Nov 2025 08:36:24 -0400

vart (2.5-5) unstable; urgency=medium

  * d/patches:
    - Add 0007-Fix-FTBFS-issues-relating-to-gcc-13-Closes-1037882.patch.
      Fix FTBFS issues relating to gcc-13 (Closes: #1037882)
      Thanks to Jonathan Bergh <bergh.jonathan@gmail.com>.
  * d/copyright:
    - Update copyright year
  * d/gbp.conf:
    - Add file.
  * d/control:
    - Bump Standards-Version to 4.7.0.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 24 Feb 2025 13:32:55 +0900

vart (2.5-4) unstable; urgency=medium

  * Change library name to load to libvart-trace.so.2.
    Add d/patches/0006-libvart-trace.so-Change-library-name-to-load.patch.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 28 Feb 2023 07:05:34 +0900

vart (2.5-3) unstable; urgency=medium

  * d/libvart2.install: install /etc/vart.conf

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 11 Jan 2023 13:46:05 +0900

vart (2.5-2) unstable; urgency=medium

  * Drop embeds build time in various binaries. (Closes: #1021792)
    Add 0005-Use-cmake-TIMESTAMP-feature-instead-of-calling-date-.patch.
    Thanks to Vagrant Cascadian <vagrant@reproducible-builds.org>.
  * d/rules: Add -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON to configure option.
    (Closes: #1021793)
    Fix buildid differences triggered by build paths.
    Thanks to Vagrant Cascadian <vagrant@reproducible-builds.org>.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 19 Oct 2022 14:01:22 +0900

vart (2.5-1) unstable; urgency=low

  [ Punit Agrawal ]
  * Initial release. (Closes: #1017822)

  [ Nobuhiro Iwamatsu ]
  * Update to 2.5.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Fri, 19 Aug 2022 16:07:43 +0900

=== debian/control ===
Source: vart
Section: libs
Priority: optional
Maintainer: Debian Xilinx Package Maintainers <team+pkg-xilinx@tracker.debian.org>
Uploaders: Punit Agrawal <punit@debian.org>,
           Nobuhiro Iwamatsu <iwamatsu@debian.org>
Build-Depends: cmake, debhelper-compat (= 13),
	dh-exec,
	libboost-filesystem-dev,
	libjson-c-dev,
	libprotobuf-dev,
	libssl-dev,
	libtarget-factory-dev,
	libunilog-dev,
	libxir-dev,
	libxrt-dev,
	uuid-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/Xilinx/Vitis-AI
Vcs-Git: https://salsa.debian.org/xilinx-packages-team/vitis-ai/vart.git
Vcs-Browser: https://salsa.debian.org/xilinx-packages-team/vitis-ai/vart

Package: libvart2
Architecture: amd64 arm64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Vitis AI RuntTime library
 Vitis AI RunTime is an application level runtime interface for DPU
 IPs based on XRT. It use XIR subgraph as input, and runs it on
 different targets. There are also emulators implemented with same
 interface to make debuging eaiser.
 .
 This package provides the runtime environment for Vitis AI RuntTime library.

Package: libvart-dev
Architecture: amd64 arm64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libvart2 (= ${binary:Version})
Description: Vitis AI RuntTime library (development)
 Vitis AI RunTime is an application level runtime interface for DPU
 IPs based on XRT. It use XIR subgraph as input, and runs it on
 different targets. There are also emulators implemented with same
 interface to make debuging eaiser.
 .
 This package provides the development environment for Vitis AI RuntTime
 library.

Package: vart-bin
Architecture: amd64 arm64
Section: utils
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Vitis AI RuntTime library (utilities)
 Vitis AI RunTime is an application level runtime interface for DPU
 IPs based on XRT. It use XIR subgraph as input, and runs it on
 different targets. There are also emulators implemented with same
 interface to make debuging eaiser.
 .
 This package contains the utility files for Vitis AI RuntTime library.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CONFIGURE_ARGS = -DCMAKE_BUILD_TYPE=Debug \
	-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	-DENABLE_DPU_RUNNER=ON \
	-DENABLE_XRNN_RUNNER=ON

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_ARGS)

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/Vitis-AI-$1.tar.gz/,dversionmangle=s/\+dfsg// \
  https://github.com/Xilinx/Vitis-AI/tags .*/v?(\d\S*)\.tar\.gz
